<template>
  <div
    class="chat__contact flex items-center px-2 pt-4 pb-2"
    :class="{ 'bg-primary-gradient text-white shadow-lg': isSelectedHabit }"
  >
    <div class="contact__avatar mr-1">
      <vs-avatar
        v-if="habitIcon && habitIcon != ''"
        class="border-2 border-solid border-white"
        :src="habitIcon"
        size="42px"
      />
      <div
        v-else
        class="rounded-full text-white text-center pt-3 m-2"
        :style="
          `height: 40px; width: 40px; background-color:${this.habit.icon.iconColor}`
        "
      >
        {{ this.habit.icon.iconText }}
      </div>

      <!-- <vs-avatar
        v-else
        class="border-2 border-solid border-white"
        :text="this.habit.icon.iconText"
        size="42px"
        variant="light-warning"
      /> -->
    </div>

    <div
      class="contact__container w-full flex items-center justify-between overflow-hidden"
    >
      <div class="contact__info flex flex-col truncate w-5/6">
        <h5 class="font-semibold" :class="{ 'text-white': isSelectedHabit }">
          {{ habit.name }}
        </h5>
        <span class="truncate">
          <small
            >{{ totalCheckIns }}/{{ this.habit.missionDayTarget }}
            {{ this.habit.missionDayUnit | textMissionDayUnitEnum }}</small
          >
        </span>
      </div>

      <!-- TRAILING -->
      <div
        class="chat__contact__meta flex self-start flex-col items-end w-1/6 mr-2"
      >
        <span class="whitespace-no-wrap">Tổng (ngày)</span>
        <h3>{{ totalDays }}</h3>
        <!-- <vs-chip class="number mt-2" color="primary">
          {{ totalDays }}
        </vs-chip> -->
      </div>
    </div>
  </div>
</template>

<script>
import { now, isSameDay } from "../../../core/utils/date";
import { groupBy } from "../../../core/utils/list";
import moment from "moment";
import { getAssetImage } from "../../../core/utils/image";

export default {
  computed: {
    habitIcon() {
      return getAssetImage(this.habit.icon.iconImage);
    },
    totalCheckIns() {
      let total = 0;
      (this.habit.habitProgress || []).forEach(log => {
        if (isSameDay(log.date, now())) {
          total += log.current;
        }
      });
      return total;
    },
    totalDays() {
      let total = 0;

      const list = (this.habit.habitProgress || []).slice();

      // group an array of objects (or subarrays) through a key
      const groupsList = Object.values(
        groupBy(list, item => moment(item.date).format("YYYY-MM-DD"))
      );

      // const result = groupsList.map(group => ({
      //   value: moment(group[0].date).format("YYYY-MM-DD"), // get key
      //   data: group
      // }));

      return groupsList.length;
    }
  },
  props: {
    habit: { type: Object, required: true },
    isSelectedHabit: { type: Boolean }
  }
};
</script>
